package de.bananaco.webgui;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;

import de.bananaco.bpermissions.api.World;
import de.bananaco.bpermissions.api.WorldManager;
import de.bananaco.bpermissions.api.util.Calculable;
import de.bananaco.bpermissions.api.util.CalculableType;

public class JSONStringWriter {
	
	public JSONStringWriter() {
		
	}
	
	
	@SuppressWarnings("unchecked")
	public String encode() {
		WorldManager wm = WorldManager.getInstance();
		JSONObject main = new JSONObject();
		for(World world : wm.getAllWorlds()) {
			JSONObject users = new JSONObject();
			JSONObject groups = new JSONObject();
			
			JSONObject w = new JSONObject();
			w.put("users", users);
			w.put("groups", groups);
			
			main.put(world.getName(), w);
			
			for(Calculable user : world.getAll(CalculableType.USER)) {
				String name = user.getName();
				JSONArray grp = new JSONArray();
				JSONArray prm = new JSONArray();
				JSONObject meta = new JSONObject();
				
				grp.addAll(user.serialiseGroups());
				prm.addAll(user.serialisePermissions());
				meta.putAll(user.getMeta());
				
				JSONObject data = new JSONObject();
				data.put("groups", grp);
				data.put("permissions", prm);
				data.put("meta", meta);
				users.put(name, data);
			}
			for(Calculable group : world.getAll(CalculableType.GROUP)) {
				String name = group.getName();
				JSONArray grp = new JSONArray();
				JSONArray prm = new JSONArray();
				JSONObject meta = new JSONObject();
				
				grp.addAll(group.serialiseGroups());
				prm.addAll(group.serialisePermissions());
				meta.putAll(group.getMeta());
				
				JSONObject data = new JSONObject();
				data.put("groups", grp);
				data.put("permissions", prm);
				data.put("meta", meta);
				groups.put(name, data);
			}
		}
		
		return main.toJSONString();
	}

}
